#include <X11/X.h>
#include <X11/xpm.h>
#include <X11/Xlib.h>
#include <pthread.h>

#include "list.h"

#define WAIT_TIMEOUT	1 /* secs */

#define WM_PREPARSED	(1 << 1)
#define WM_INITIALIZED	(1 << 2)
#define WM_MAPPED	(1 << 3)
#define WM_ACTIVATED	(1 << 4)
#define WM_EXPOSED	(1 << 5)

struct wm_exec {
	char *command;
	struct list_head trig;
	struct list_head others[];
};

struct wm_identity {
	struct list_head others;
	int index;
	char *name;
	char *icon;
	Pixmap icon_on, icon_off;
	Pixmap mask_on, mask_off;
	struct list_head exec;
};

struct wm_people {
	int status;

	char *server;
	int port;
	char *user, *pass;
	char *theme;
	char *icon;
	struct wm_exec cmd;

	struct wm_identity *identity;
	int identities;

	Pixmap icon_on, icon_off;
	Pixmap mask_on, mask_off;

	int offs_x, offs_y;
	int icon_w, icon_h;
	int grid_w, grid_h;

	Display *display;
	Window iconwin, balwin;
	GC mono, draw;
	int root;
	unsigned long bp, wp;

	Font font;
	XFontStruct *fs;
	Pixmap pixmap;
	int width, height;
	int side;

	int sock;

 	pthread_mutex_t lock;
	int data[128];
	int offset;

	/* scratch data */

	XpmAttributes attrs;
	char name[255];
};
